Generator = {}
Generator.TimeToStart = 0
Generator.Loaded = false;

require 'Patterns'

function Generator.New(w, h)
	local Level = {};
	Level.path = {};
	for j = 1, h do
		Level[j] = {}
		for i = 1, w do
			Level[j][i] = 34;
		end
	end
	return Level;
end

function Generator.CellSet(w, x, y, val)
	if(w[math.floor(y)] ~= nil) then
		w[math.floor(y)][math.floor(x)] = val;
	end
end

function Generator.CellGet(w, x, y)
	return w[y][x];
end

function Generator.Free(w)
	for j, h in ipairs(w) do
		for i, ww in ipairs(h) do
			ww = nil;
		end
		h = nil;
	end
	w = nil;
end

function Generator.Room(w, x, y, radius, index)
	for i = -math.floor(radius/2), radius do
		for j = -math.floor(radius/2), radius do
			Generator.CellSet(w, x + i, y + j, index)
		end
	end
end

function Generator.RectRoom(w, x, y, l, h, index)
	for i = 1, l do
		for j = 1, h do
			Generator.CellSet(w, x + i, y + j, index)
		end
	end
end


function Generator.AB(w, x1, y1, x2, y2, angles)
	local mX = x1;
	local mY = y1;

	local Angle = 0
	local Length = math.floor(Engine.GetDistantion(x1, y1, x2, y2) / angles * 3)
	local Pos = {x1, x2}
	local LastPoint = 0;
	local Pattern = math.floor(love.math.random(2))
	table.insert(w.path, Pos)

	for i = 0, angles do
		TextLoading = "Generating Level..."
		if(i ~= angles) then
			if(Pattern ~= 1) then
				Angle = math.floor( (Engine.GetDirection(mX, mY, x2, y2) + love.math.random(-math.pi/4, math.pi/4) ) / (math.pi/2) ) * (math.pi/2);
			end
			Length = 6 + math.floor(love.math.random(5))
		else
			Angle = math.floor( (Engine.GetDirection(mX, mY, x2, y2) + love.math.random(-math.pi/4, math.pi/4)) / (math.pi/2) ) * (math.pi/2);
			Length = 6 + math.floor(love.math.random(5))--(Engine.GetDistantion(mX, mY, x2, y2) / angles * 3)
		end

		for j = 0, Length do
			if(mX + math.floor(math.cos(Angle) * j) - 1 > 0 and mY + math.floor(math.sin(Angle) * j) - 1 > 0) then
				Generator.Room(w, mX + math.floor(math.cos(Angle) * j), mY + math.floor(math.sin(Angle) * j), 2, 42)
				Pos = {mX + math.floor(math.cos(Angle) * j), mY + math.floor(math.sin(Angle) * j)}
				table.insert(w.path, Pos)
			else
				mX = mX + math.floor(math.cos(Angle) * j);
				mY = mY + math.floor(math.sin(Angle) * j);

				break;
			end
			if( j == Length) then
				if(Pattern == 1 and Length > 12) then
					if(Angle == math.pi or Angle == 0) then
						Generator.InsertPattern(JustRoom, w, mX + math.floor(math.cos(Angle) * j) + 2, mY + math.floor(math.sin(Angle) * j) - 5)
						mX = mX + math.floor(math.cos(Angle) * j) - 2;
						mY = mY + math.floor(math.sin(Angle) * j);
					end
				end

				if(i ~= angles) then
					mX = mX + math.floor(math.cos(Angle) * j);
					mY = mY + math.floor(math.sin(Angle) * j);
					LastPoint = j
				end
			end
		end
		if(i == angles) then
			Generator.Room(w, mX + math.floor(math.cos(Angle) * LastPoint), mY + math.floor(math.sin(Angle) * LastPoint) - 1, 4, 42)
			Generator.RectRoom(w, mX + math.floor(math.cos(Angle) * LastPoint) - 2, mY + math.floor(math.sin(Angle) * LastPoint) - 2, 3, 3, 16)
			Generator.RectRoom(w, mX + math.floor(math.cos(Angle) * LastPoint) - 2, mY + math.floor(math.sin(Angle) * LastPoint), 3, 1, 10)
			break;
		end

		Pattern = math.floor(love.math.random(2))
	end
end

function Generator.GenerateLevel(l)
	local xs, ys =  384 - 48, 384/2
	
	local x1, y1, x2, y2 = 48, 384/2, 384 - 48, 384/2

	Generator.AB(l, x1, y1, x2, y2, 48)

	Generator.Room(l, x1, y1-1, 4, 42)
	Generator.RectRoom(l, x1 - 2, y1 - 2, 3, 3, 8)
	Generator.RectRoom(l, x1 - 2, y1, 3, 1, 10)

	TextLoading = "Change some tiles..."
	local sp = math.floor(love.math.random(8))
	for j, v in ipairs(l) do	
		
		for i, b in ipairs(v) do
			if(b ~= 0) then
				if(b == 34) then
					if(InsertSolidArea(l, j - 1, i + 1) and InsertSolidArea(l, j, i + 1) and InsertSolidArea(l, j - 1, i) or InsertSolidArea(l, j + 1, i - 1) and InsertSolidArea(l, j, i - 1) == false and InsertSolidArea(l, j + 1, i) == false) then
						l[j][i] = 3
					end

					if(InsertSolidArea(l, j + 1, i + 1) and InsertSolidArea(l, j, i + 1) and InsertSolidArea(l, j + 1, i) or InsertSolidArea(l, j - 1, i - 1) and InsertSolidArea(l, j, i - 1) == false and InsertSolidArea(l, j - 1, i) == false) then
						l[j][i] = 19
					end

					if(InsertSolidArea(l, j + 1, i - 1) and InsertSolidArea(l, j, i - 1) and InsertSolidArea(l, j + 1, i) or InsertSolidArea(l, j - 1, i + 1) and InsertSolidArea(l, j, i + 1) == false and InsertSolidArea(l, j - 1, i) == false) then
						l[j][i] = 17
					end

					if(InsertSolidArea(l, j - 1, i - 1) and InsertSolidArea(l, j, i - 1) and InsertSolidArea(l, j - 1, i) or InsertSolidArea(l, j + 1, i + 1) and InsertSolidArea(l, j, i + 1) == false and InsertSolidArea(l, j + 1, i) == false) then
						l[j][i] = 1
					end

					if(InsertSolidArea(l, j + 1, i) and InsertSolidArea(l, j, i - 1) and InsertSolidArea(l, j, i + 1) and InsertSolidArea(l, j - 1, i) == false) then
						l[j][i] = 12
					end

					if(InsertSolidArea(l, j - 1, i) and InsertSolidArea(l, j, i - 1) and InsertSolidArea(l, j, i + 1) and InsertSolidArea(l, j + 1, i) == false) then
						l[j][i] = 20
					end

					if (l[j] ~= nil) then
						if(l[j][i] == 34) then
							if(InsertSolidArea(l, j + 1, i)) then
								l[j][i] = 2
							end

							if(InsertSolidArea(l, j - 1, i)) then 
								l[j][i] = 2
							end

							if(InsertSolidArea(l, j, i - 1)) then
								l[j][i] = 9
							end

							if(InsertSolidArea(l, j, i + 1)) then
								l[j][i] = 9
							end
						end
					end
				end
			end
		end
	end

	--Decoration
	for j, v in ipairs(l) do
		for i, b in ipairs(v) do
			sp = math.floor(love.math.random(8)) + 1
			if(b == 42) then
				if(sp == 6) then
					if(l[j+1] ~= nil and l[j+1][i] == 2) then
						Generator.Spikes(l, 6, i, j)
					end
				end

				if(sp == 2) then
					if(l[j+1] ~= nil and l[j+1][i] == 2) then
						Generator.ComputerWall(l, i, j)
						for t = 1, 3 do
							if(l[j][i + t] == 42 and l[j + 1][i] == 2) then
								Generator.ComputerWall(l, i + t, j)
							end
						end
					end
				end

				if(sp == 7) then
					if(l[j+1] ~= nil and l[j-1] ~= nil and l[j+1][i] == 2 and l[j-1][i] == 42) then
						Chest(i, j)
					end
				end
			end
		end
	end
	
	Generator.Loaded = true;
end

function InsertSolidArea(w, j, i)
	return (w[j] ~= nil and w[j][i] == 42)
end

function Generator.Spikes(w, width, i, j)
	for n = 0, width do
		if(w[j][i + n] == 42 and w[j + 1][i + n] == 2) then
			w[j][i + n] = 44
		else
			break;
		end
	end
end

function Generator.ComputerWall(w, i, j)
	local n = 0;
	local lim = 1 + math.floor(math.random()*3);
	local lim2 = math.floor(math.random()*2)
	while(n ~= lim)do
		if(w[j - n][i] == 42) then w[j - n][i] = 47 end
		n = n + 1
	end
	if(w[j - n + lim2][i] == 42) then
		w[j - n + lim2][i] = 39
	end
end

function Generator.MapSave()
	local t = FileWriteOpen('./Level.lua')
	FileWrite(t, "--Level Start--")
	FileWriteln(t)
	FileWrite(t, "Level = {")
	FileWriteln(t)
	for j = 1, table.maxn(Level) do
		FileWrite(t,"	{")
		for i = 1, table.maxn(Level) do
			if(i < table.maxn(Level)) then FileWrite(t, Level[j][i] + ",") else FileWrite(t, Level[j][i]) end
		end
		if(j < table.maxn(Level)) then
			FileWrite(t,"},")
			FileWriteln(t)
		else
			FileWrite(t, "}")
			FileWriteln(t)
		end
	end
	FileWrite(t, "};")
	FileWrite(t, "--Level End--")
	FileWriteln(t)

	FileWriteClose(t);
end


function Generator.InsertPattern(table, w, x, y)
	local t = table;

	for j, v in ipairs(t) do
		for i, b in ipairs(v) do
			if(w[y + j - 1]~= nil) then
				w[y + j - 1][x + i - 1] = b;
			end
		end
	end
end