Enemies = {};
Bullets = {};
Sprite = {
	{ love.graphics.newImage('Graphics/PlayerRun.png'), 38 }, --Run 1
	{ love.graphics.newImage('Graphics/PlayerIdle.png'), 50 }, --Idle 2 
	{ love.graphics.newImage('Graphics/MonsterRun.png'), 58 }, --Run 3 
	{ love.graphics.newImage('Graphics/MonsterIdle.png'), 28 }, --Idle 4
	{ love.graphics.newImage('Graphics/Weapon.png'), 0}, --Weapon 5
	{ love.graphics.newImage('Graphics/BombZombieRun.png'), 38}, --BombZombie 6
	{ love.graphics.newImage('Graphics/Coin.png'), 0}, --Part 7
	{ love.graphics.newImage('Graphics/PpdEnem.png'), 28},--8
	{ love.graphics.newImage('Graphics/CrazyBunny.png'), 29},--9
	{ love.graphics.newImage('Graphics/CoinR.png'), 0},--10
	{ love.graphics.newImage('Graphics/Chest.png'), 1},--11
	{ love.graphics.newImage('Graphics/Health.png'), 0}--12
}
Buttons = {}

Item = {Sprite[10][1], Sprite[12][1]}

TitlesDead = {
	"Not Bad!",
	"Good!",
	"Waah!",
	"Master!",
	"Devil!!!"
}


function PlayerCreate(gx, gy)
	local this = {};
	this.x = gx * 32;
	this.y = gy * 32;
	this.xstart = this.x;
	this.ystart = this.y;
	this.vSpeed = 0;
	this.hSpeed = 0;
	this.scaleX = 1;
	this.scaleY = 1;
	this.Friction = 0.9;
	this.Gravity = 0;
	this.Recoil = 0;
	this.HP = 100;
	this.Direction = 0
	this.Weapon = 1

	this.WeaponStats = {
		{1500, 1, 0.5, 10, "Rifle", 1},
		{1300, 5, 0.9, 5, "Shotgun"}
	}

	local WeaponStats = this.WeaponStats;
	
	--Sprites
	local AnimRun = Sprite[1];
	local AnimIdle = Sprite[2];	
	local SpriteIndex = AnimRun;
	local ImageIndex = 0;
	local Frame = love.graphics.newQuad(0, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
	local Touch = false;
	local Speed = 25;

	--GrapHook
	local GrapHook = false;
	local HookX = this.x;
	local HookY = this.y;
	local HookAttached = false;
	local HookDir = 0;
	local HookSpeed = 2000;

	--Player
	local Life = true;

	this.Update = function(dt)
		if(this.HP > 1) then

			this.Direction = Engine.GetDirection(this.x, this.y + 8, Engine.MouseX, Engine.MouseY);
			this.x = this.x + this.hSpeed * dt; this.hSpeed = this.hSpeed * this.Friction;
			this.y = this.y + this.vSpeed * dt; this.vSpeed = this.vSpeed + this.Gravity * dt;
			
			this.Recoil = this.Recoil - (this.Recoil - 1)/8;

			if(ImageIndex > SpriteIndex[2]) then
				ImageIndex = 0;
			end

			Touch = LevelMatrix.HitTest(tTiles, this.x, this.y + 25)
			this.Weapon = math.max(1, math.min(this.Weapon, 2))
			dt = math.min(dt, 2)

			if(Touch) then
				ImageIndex = math.floor(ImageIndex + 75 * dt);
				Frame = love.graphics.newQuad(32 * ImageIndex, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
				
				if(love.keyboard.isDown("a", "d") ~= true) then
					if(SpriteIndex ~= AnimIdle) then 
						SpriteIndex = AnimIdle; ImageIndex = 0;
						Frame = love.graphics.newQuad(0, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
					end
				else
					if(SpriteIndex ~= AnimRun) then 
						SpriteIndex = AnimRun; ImageIndex = 0;
						Frame = love.graphics.newQuad(0, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
					end
				end
				this.Gravity = 0;
			else
				SpriteIndex = AnimRun;
				Frame = love.graphics.newQuad(32 * 6, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight())
				this.Gravity = 1500; 
			end

			--Collision
			if (LevelMatrix.HitTest(tTiles, this.x, this.y + 24)) then
				this.y = this.y - math.abs(this.vSpeed * dt);
				this.vSpeed = 0
			end

			if (LevelMatrix.HitTest(tTiles, this.x, this.y - 8 - math.abs(this.vSpeed * dt) )) then
				this.y = this.y + math.abs(this.vSpeed * dt)
				this.vSpeed = 200
			end

			if (LevelMatrix.HitTest(tTiles, this.x - 8 - math.abs(this.hSpeed * dt), this.y + 22)) then
				this.x = this.x + math.abs(this.hSpeed * dt)
				this.hSpeed = 0
			end

			if (LevelMatrix.HitTest(tTiles, this.x + 8 + math.abs(this.hSpeed * dt), this.y + 22)) then
				this.x = this.x - math.abs(this.hSpeed * dt)
				this.hSpeed = 0
			end

			if(love.keyboard.isDown("d")) then 
				if (LevelMatrix.HitTest(tTiles, this.x + 8 + Speed * dt, this.y + 23) == false) then
					this.hSpeed = this.hSpeed + Speed; 
				end
			end

			if(love.keyboard.isDown("a")) then 
				if (LevelMatrix.HitTest(tTiles, this.x - 8 - Speed * dt, this.y + 23) == false) then
					this.hSpeed = this.hSpeed - Speed; 
				end
			end

			if(LevelMatrix.GetCell(tTiles, this.x, this.y) == 44) then
				this.vSpeed = -400
				this.HP = this.HP - 5
			end

			if(LevelMatrix.GetCell(tTiles, this.x, this.y) == 16) then
				Sector = Sector + 1
				Game.reset()
			end

			if (Engine.MouseX > this.x) then
				this.scaleX = 1;
			else
				this.scaleX = -1;
			end

			if(love.mouse.isDown('l')) then
				if(this.Recoil > WeaponStats[this.Weapon][3]) then 
					for i = 1, WeaponStats[this.Weapon][2] do
						Bullet(this.x + math.cos(this.Direction) * 16, this.y + 8 + math.sin(this.Direction) * 16, WeaponStats[this.Weapon][1], this.Direction, WeaponStats[this.Weapon][4]);
					end
					Audio.PlayWithPitch(1, 1+math.random() * 0.5);
					this.Recoil = 0;
				end
			end

			if(love.keyboard.isDown('1')) then this.Weapon = 1 end
			if(love.keyboard.isDown('2')) then this.Weapon = 2 end

			if(love.keyboard.isDown(" "))  then
				if(Touch) then 
					this.vSpeed = -500 
				end
			end

			--Grappling Hook
			GrapHook = love.mouse.isDown('r')

			if(GrapHook == true) then
				if(LevelMatrix.HitTest(tTiles, HookX, HookY) == false) then
					HookX = HookX + math.cos(HookDir) * HookSpeed * dt
					HookY = HookY + math.sin(HookDir) * HookSpeed * dt
					for i = 0, math.floor(HookSpeed * dt) do
						if(LevelMatrix.HitTest(tTiles, HookX + math.cos(HookDir) * i, HookY + math.sin(HookDir) * i)) then 
								HookX = HookX + math.cos(HookDir) * i
								HookY = HookY + math.sin(HookDir) * i
							break 
						end
					end
				else
					this.hSpeed = this.hSpeed + math.cos(Engine.GetDirection(this.x, this.y + 8, HookX, HookY)) * 60
					this.vSpeed = this.vSpeed + math.sin(Engine.GetDirection(this.x, this.y + 8, HookX, HookY)) * 60
				end
			else

				HookX = this.x;
				HookY = this.y;
			end
		end
	end

	this.Draw = function()
		if(this.HP > 1) then
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.draw(SpriteIndex[1], Frame, this.x, this.y, 0, this.scaleX, this.scaleY, 16, 24)

			for i = 0, love.window.getWidth() do
				love.graphics.setLineWidth(2)
				local RayX = this.x + math.cos(this.Direction)*i;
				local RayY = this.y + 8 + math.sin(this.Direction)*i;
				love.graphics.setColor(255, 0, 0, 128);
				if(LevelMatrix.HitTest(tTiles, RayX, RayY) or i == love.window.getWidth()) then
					love.graphics.line(this.x + math.cos(this.Direction) * 16, this.y + 8 + math.sin(this.Direction) * 16, RayX, RayY)
					love.graphics.circle('fill', RayX, RayY, 4)
					break;
				end
			end

			
			if(GrapHook) then
				love.graphics.line(this.x, this.y + 8, HookX, HookY)
				love.graphics.circle('fill', HookX, HookY, 4)
			end
			love.graphics.draw(Sprite[5][1], love.graphics.newQuad(0, 0, 16, 16, 16, 16), this.x + math.cos(this.Direction) * 16 * this.Recoil , this.y + 8 + math.sin(this.Direction) * 16 * this.Recoil, this.Direction, 1, this.scaleX, 2, 8)
		end
	end

	this.MouseDown = function()
		if(this.HP > 1) then
			if(love.mouse.isDown('r')) then
				HookDir = this.Direction;
			end
		end
	end

	return this;
end

function Zombie(gx, gy, player)
	local this = {};
	this.x = gx;
	this.y = gy;
	this.vSpeed = 0;
	this.hSpeed = 0;
	this.scaleX = 1;
	this.scaleY = 1;
	this.Friction = 0.8;
	this.Gravity = 1500;
	this.Speed = 60;
	this.myTarget = player;
	this.HP = 30 + Sector;

		--Sprites
	local AnimRun = Sprite[9];
	local AnimIdle = Sprite[9];	
	local SpriteIndex = AnimRun;
	local ImageIndex = 0;
	local Frame = love.graphics.newQuad(0, 0, 48, 64, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
	local CoinsCount = 1 + math.floor(math.random() * 4)

	if (LevelMatrix.HitTest(tTiles, this.x, this.y)) then ObjectRemove(this); end

	this.update = function(dt)
		this.x = this.x + this.hSpeed * dt; this.hSpeed = this.hSpeed * this.Friction;
		this.y = this.y + this.vSpeed * dt; this.vSpeed = this.vSpeed + this.Gravity * dt;

		--Animation Control
		ImageIndex = math.floor(ImageIndex + 75 * dt);

		if(ImageIndex > SpriteIndex[2]) then
			ImageIndex = 0;
		end

		if(LevelMatrix.GetCell(tTiles, this.x, this.y) == 0  or LevelMatrix.GetCell(tTiles, this.x, this.y) == 34) then
			ObjectRemove(this);
		end

		Frame = love.graphics.newQuad(48 * ImageIndex, 0, 48, 64, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());

		local Touch = LevelMatrix.HitTest(tTiles, this.x, this.y + 33)

		if(Touch) then
			this.Gravity = 0;
		else
			this.Gravity = 1500;
		end
		if(LevelMatrix.HitTest(tTiles, this.x + 30, this.y + 24) or LevelMatrix.HitTest(tTiles, this.x - 30, this.y + 24)) then
			if(Touch) then this.vSpeed = -400; end
		end
			--Collision
		--Collision
		if (LevelMatrix.HitTest(tTiles, this.x, this.y + 24)) then
			this.y = this.y - math.abs(this.vSpeed * dt);
			this.vSpeed = 0
		end

		if (LevelMatrix.HitTest(tTiles, this.x, this.y - 8 - math.abs(this.vSpeed * dt) )) then
			this.y = this.y + math.abs(this.vSpeed * dt)
			this.vSpeed = math.abs(this.vSpeed);
		end

		if (LevelMatrix.HitTest(tTiles, this.x - 8 - math.abs(this.hSpeed * dt), this.y + 24)) then
			this.x = this.x + math.abs(this.hSpeed * dt)
			this.hSpeed = 0
		end

		if (LevelMatrix.HitTest(tTiles, this.x + 8 + math.abs(this.hSpeed * dt), this.y + 24)) then
			this.x = this.x - math.abs(this.hSpeed * dt)
			this.hSpeed = 0
		end

		if(math.sqrt( (this.myTarget.x - this.x) ^ 2 + (this.myTarget.y - this.y)^2 ) > 32) then
			if(SpriteIndex ~= AnimRun) then
				SpriteIndex = AnimRun; ImageIndex = 0;
				Frame = love.graphics.newQuad(0, 0, 48, 64, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
			end
			if (this.myTarget.x > this.x) then
				this.scaleX = 1;
				if(LevelMatrix.HitTest(tTiles, this.x + 8 + math.abs(this.Speed * dt), this.y + 24) == false) then
					this.hSpeed = this.hSpeed + this.Speed;
				end
			else
				this.scaleX = -1;
				if(LevelMatrix.HitTest(tTiles, this.x - 8 - math.abs(this.Speed * dt), this.y + 24) == false) then
					this.hSpeed = this.hSpeed - this.Speed;
				end
			end
		else
			if(SpriteIndex ~= AnimIdle) then
				SpriteIndex = AnimIdle; ImageIndex = 0;
				Frame = love.graphics.newQuad(0, 0, 48, 64, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
			end
			this.myTarget.HP = this.myTarget.HP - 0.05;
		end

		if(Engine.GetDistantion(this.x, this.y, this.myTarget.x, this.myTarget.y) > 512) then
			ObjectRemove(this);
		end

		if(this.HP < 1) then
			JustText("+100! "+TitlesDead[CoinsCount], this.x, this.y)
			Scores = Scores + 100;

			for i = 1, CoinsCount do
				Coin(this.x, this.y)
			end
			Audio.PlayWithPitch(7, 1+math.random() * 0.5)
			ObjectRemove(this);
		end	
	end


	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(SpriteIndex[1], Frame, this.x, this.y, 0, this.scaleX - 0.2 * (this.scaleX/math.abs(this.scaleX)), this.scaleY - 0.2 * (this.scaleY/math.abs(this.scaleY)), 24, 32)
		if(this.HP < 100) then
			love.graphics.setColor(255, 0, 0, 255)
			love.graphics.rectangle('line', this.x - 16, this.y - 32, 32*(this.HP/30), 8)
		end
	end
	
	table.insert(Enemies, this);
end

function BombZombie(gx, gy, player)
	local this = {};
	this.x = gx;
	this.y = gy;
	this.vSpeed = 0;
	this.hSpeed = 0;
	this.scaleX = 1;
	this.scaleY = 1;
	this.Friction = 0.8;
	this.Gravity = 1500;
	this.Speed = 50;
	this.myTarget = player;
	this.HP = 50;

		--Sprites
	local AnimRun = Sprite[6];
	local SpriteIndex = AnimRun;
	local ImageIndex = 0;
	local Frame = love.graphics.newQuad(0, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());

	this.update = function(dt)
		this.x = this.x + this.hSpeed * dt; this.hSpeed = this.hSpeed * this.Friction;
		this.y = this.y + this.vSpeed * dt; this.vSpeed = this.vSpeed + this.Gravity * dt;

		--Animation Control
		ImageIndex = math.floor(ImageIndex + 75 * dt);

		if(ImageIndex > SpriteIndex[2]) then
			ImageIndex = 0;
		end

		if(LevelMatrix.GetCell(tTiles, this.x, this.y) == 34) then
			ObjectRemove(this);
		end

		Frame = love.graphics.newQuad(32 * ImageIndex, 0, 32, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());

		local Touch = LevelMatrix.HitTest(tTiles, this.x, this.y + 25)

		if(Touch) then
			this.Gravity = 0;
		else
			this.Gravity = 1500;
		end

		--Collision
		if (LevelMatrix.HitTest(tTiles, this.x, this.y + 24)) then
			this.y = this.y - math.abs(this.vSpeed * dt);
			this.vSpeed = 0
		end

		if (LevelMatrix.HitTest(tTiles, this.x, this.y - 8 - math.abs(this.vSpeed * dt) )) then
			this.y = this.y + math.abs(this.vSpeed * dt)
			this.vSpeed = math.abs(this.vSpeed);
		end

		if (LevelMatrix.HitTest(tTiles, this.x - 8 - math.abs(this.hSpeed * dt), this.y + 23)) then
			this.x = this.x + math.abs(this.hSpeed * dt)
			this.hSpeed = 0
		end

		if (LevelMatrix.HitTest(tTiles, this.x + 8 + math.abs(this.hSpeed * dt), this.y + 23)) then
			this.x = this.x - math.abs(this.hSpeed * dt)
			this.hSpeed = 0
		end


		if(LevelMatrix.HitTest(tTiles, this.x + 16, this.y + 23) or LevelMatrix.HitTest(tTiles, this.x - 16, this.y + 23)) then
			if(Touch) then this.vSpeed = -400; end
		end

		if(math.sqrt( (this.myTarget.x - this.x) ^ 2 + (this.myTarget.y - this.y)^2 ) > 32) then
			if (this.myTarget.x > this.x) then
				this.scaleX = 1;
				if(LevelMatrix.HitTest(tTiles, this.x + 8 + math.abs(this.Speed * dt), this.y + 23) == false) then
					this.hSpeed = this.hSpeed + this.Speed;
				end
			else
				this.scaleX = -1;
				if(LevelMatrix.HitTest(tTiles, this.x - 8 - math.abs(this.Speed * dt), this.y + 23) == false) then
					this.hSpeed = this.hSpeed - this.Speed;
				end
			end
		else
			this.myTarget.HP = this.myTarget.HP - 20;
			Explode(this.x, this.y);
			ObjectRemove(this);
		end

		if(this.HP < 1) then
			Explode(this.x, this.y);
			ObjectRemove(this);
		end	
	end


	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(SpriteIndex[1], Frame, this.x, this.y, 0, this.scaleX, this.scaleY, 16, 24)
		if(this.HP < 100) then
			love.graphics.setColor(255, 0, 0, 255)
			love.graphics.rectangle('line', this.x - 16, this.y - 32, 32*(this.HP/100), 8)
		end
	end
	
	table.insert(Enemies, this);
end

function CrazyBird(gx, gy, player)
	local this = {};
	this.x = gx;
	this.y = gy;
	this.vSpeed = 0;
	this.hSpeed = 0;
	this.scaleX = 1;
	this.scaleY = 1;
	this.Friction = 0.98;
	this.Gravity = 0;
	this.Speed = 50;
	this.myTarget = player;
	this.HP = 20;
	this.StartHp =  this.HP
	this.Flyer = true;


		--Sprites
	local AnimRun = Sprite[8];
	local SpriteIndex = AnimRun;
	local ImageIndex = 0;
	local Frame = love.graphics.newQuad(0, 0, 48, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
	local Rotation = 0;
	local Dir = 0;
	local CoinsCount = 1 + math.floor(math.random() * 4)
	this.update = function(dt)

		this.x = this.x + this.hSpeed * dt; this.hSpeed = this.hSpeed * this.Friction;
		this.y = this.y + this.vSpeed * dt; this.vSpeed = this.vSpeed * this.Friction;

		Rotation = Engine.GetDirection(0, 0, this.hSpeed, this.vSpeed)
		Dir = Engine.GetDirection(this.x, this.y, player.x, player.y)

		this.hSpeed = this.hSpeed + math.cos(Dir) * 10;
		this.vSpeed = this.vSpeed + math.sin(Dir) * 10;
		for i = 1, 24 do
			if(this.hSpeed ~= 0) then
				if(LevelMatrix.HitTest(tTiles, this.x + i * (this.hSpeed/math.abs(this.hSpeed)), this.y)) then
					this.hSpeed = -this.hSpeed;
				end
			end

			if(this.vSpeed ~= 0) then
				if(LevelMatrix.HitTest(tTiles, this.x, this.y + i * (this.vSpeed/math.abs(this.vSpeed)))) then
					this.vSpeed = -this.vSpeed;
				end
			end
		end
		ImageIndex = math.floor(ImageIndex + 75 * dt);
		if(ImageIndex > SpriteIndex[2]) then
			ImageIndex = 0;
		end

		Frame = love.graphics.newQuad(48 * ImageIndex, 0, 48, 48, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());

		if(this.hSpeed > 0) then
			this.scaleY = 1;
		else
			this.scaleY = -1;
		end

		if(this.HP < 1) then  
			JustText('+150 ' +TitlesDead[CoinsCount], this.x, this.y)
			for i = 1, CoinsCount do
				Coin(this.x, this.y)
			end

			Audio.PlayWithPitch(7, 1+math.random() * 0.5)
			Scores = Scores + 150
			ObjectRemove(this) 
		end

		if(Engine.GetDistantion(this.x, this.y, player.x, player.y) > 512) then ObjectRemove(this) end
		if(Engine.GetDistantion(this.x, this.y, player.x, player.y) < 32) then
			this.myTarget.HP = this.myTarget.HP - 0.1;
		end

		if(LevelMatrix.GetCell(tTiles, this.x, this.y) == 0  or LevelMatrix.GetCell(tTiles, this.x, this.y) == 34) then
			ObjectRemove(this);
		end

	end

	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(SpriteIndex[1], Frame, this.x, this.y, Rotation, this.scaleX, this.scaleY, 24, 24)
		if(this.HP < this.StartHp) then
			love.graphics.setColor(255, 0, 0, 255)
			love.graphics.rectangle('line', this.x - 16, this.y - 32, 32*(this.HP/this.StartHp), 8)
		end
	end

	table.insert(Enemies, this);
end

function ObjectsUpdate(dt)
	for i, v in ipairs(Enemies) do
		v.update(dt)
	end

	for i, v in ipairs(Bullets) do
		v.update(dt)
	end
end

function ObjectsDraw()
	for i, v in ipairs(Enemies) do
		v.draw()
	end

	for i, v in ipairs(Bullets) do
		v.draw()
	end
end

function Bullet(x, y, speed, dir, dmg)
	local this = {}
	this.x = x;
	this.y = y;
	this.spd = speed;
	this.dir = dir + (-math.random()*0.1 + math.random()*0.1);
	this.dmg = dmg;

	this.update = function(dt)
		local spd = this.spd * dt;
		this.x = this.x + math.cos(this.dir) * spd;
		this.y = this.y + math.sin(this.dir) * spd;

		for i = 1, table.maxn(Enemies) do
			local o = Enemies[i];
			if(o ~= nil) then
				if(Engine.GetDistantion(this.x, this.y, o.x, o.y) < 16) then
					--Particle.Burst1(5, Sprite[7][1], o.x, o.y, Engine.GetDirection(o.x, o.y, o.myTarget.x, o.myTarget.y) + math.pi, 300, 255, 0, 0)
					o.HP = o.HP - this.dmg;
					if(o.myTarget.x > o.x) then
						o.hSpeed = -600
					else
						o.hSpeed = 600
					end

					if(o.Flyer ~= nil) then
						if(o.myTarget.y > o.y) then
							o.vSpeed = -600
						else
							o.vSpeed = 600
						end
					else
						o.vSpeed = -100
					end

					
					Audio.Play( math.floor( 1 + math.random() * 4 ) )
					ObjectRemove(this);
				end
			end
		end

		
		for i = 1, math.floor(spd) do
			if(LevelMatrix.HitTest(tTiles, this.x + math.cos(this.dir) * i, this.y + math.sin(this.dir) * i) or LevelMatrix.GetCell(tTiles, this.x, this.y) == 0) then
				ObjectRemove(this);
			end

			if(LevelMatrix.GetCell(tTiles, this.x + math.cos(this.dir) * i, this.y + math.sin(this.dir) * i) == 37) then
				Generator.CellSet(Level, (this.x + math.cos(this.dir) * i)/32, (this.y + math.sin(this.dir) * i)/32, 42)
				ObjectRemove(this);
			end
		end
	end

	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255);
		love.graphics.circle('fill', this.x, this.y, 3, 4 )
	end

	table.insert(Bullets, this);
end

function ObjectRemove(id)
	for i, b in ipairs(Enemies) do
		if(b == id) then
			b = nil;
			table.remove(Enemies, i);
			break;
		end
	end

	for i, b in ipairs(Bullets) do
		if(b == id) then
			b = nil;
			table.remove(Bullets, i);
			break;
		end
	end
end

function ObjectsRemoveAll()
	for i = 1, table.maxn(Enemies) do
		Enemies[i] = nil
		table.remove(Enemies, 1);
	end

	for j = 1, table.maxn(Bullets) do
		Bullets[j] = nil
		table.remove(Bullets, 1);
	end
end

function JustText(str, x, y)
	local this = {};
	this.x = x;
	this.y = y;
	this.str = str;

	local Alpha = 1;
	local Amp = 0.5;
	local Pow = 0

	this.update = function(dt)
		Alpha = Alpha - 0.01;
		Amp = Amp - Amp / 16;
		Pow = Pow + 1

		if(Alpha < 0.01) then
			ObjectRemove(this)
		end

		this.y = this.y - 20 * dt;
	end

	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255 * Alpha)
		love.graphics.print(this.str, this.x, this.y, 0, 1 + math.sin(Pow) * Amp, 1 - math.sin(Pow) * Amp, gameFont:getWidth(this.str)/2, gameFont: getHeight()/2)
	end

	table.insert(Bullets, this)
end

function Button(title, y, func) 
	local this = {}
	this.title = title;
	this.func = func;
	this.width = gameFont:getWidth(this.title);
	this.height = gameFont:getHeight();
	this.x = -this.width
	this.y = y;

	local Selected = false;
	local MyScene = CurrentScene;

	this.update = function(dt)
		Selected = Engine.CheckMouseBox(this.x, this.y - this.height/2, this.width, this.height)
		if(MyScene == CurrentTransform) then 
			this.x = this.x - (this.x - 0)/8 
		else
			this.x = this.x - (this.x - (-this.width))/8 
		end

		this.width = gameFont:getWidth(this.title);
	end

	this.draw = function()
		if(Selected) then
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.rectangle('fill', this.x, this.y - this.height/2, this.width, this.height)
			love.graphics.setColor(30, 30, 30, 255)
			love.graphics.print(this.title, this.x, this.y, 0, 1, 1, 0, this.height/2)
		else
			love.graphics.setColor(30, 30, 30, 255)
			love.graphics.rectangle('fill', this.x, this.y - this.height/2, this.width, this.height)
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.print(this.title, this.x, this.y, 0, 1, 1, 0, this.height/2)
		end
	end

	this.released = function()
		if(Selected) then this.func(); end
	end

	table.insert(Buttons, this)
	return this;
end

function ButtonsUpdate(dt)
	for i = 1, table.maxn(Buttons) do
		Buttons[i].update(dt)
	end
end

function ButtonsDraw()
	for i = 1, table.maxn(Buttons) do
		Buttons[i].draw()
	end
end

function ButtonsReleased()
	for i = 1, table.maxn(Buttons) do
		if(Buttons[i] ~= nil and Buttons[i].released ~= nil) then
			Buttons[i].released()
		end
	end
end

function ButtonsDeleteAll() 
	for i = 1, table.maxn(Buttons) do
		Buttons[i] = nil
		table.remove(Buttons, 1)
	end
end

function Coin(x, y)
	local this = {}
	this.x = x;
	this.y = y;
	this.id = 1;
	this.name = "Just Coins"
	this.func = function() InsertItemInventory(this) end
	local hSpeed = love.math.random(-400, 400);
	local vSpeed = love.math.random(-400, -100);
	local Gravity = 20;
	local Touch = false;
	local spr = Sprite[10][1];
	local Power = 0

	this.update = function(dt)
		this.x = this.x + hSpeed * dt; hSpeed = hSpeed * 0.99;
		this.y = this.y + vSpeed * dt; vSpeed = vSpeed + Gravity;

		Touch = LevelMatrix.HitTest(tTiles, this.x, this.y + 13)
		--[[if(Touch) then
			Gravity = 0
		else	
			Gravity = 40
		end]]

		for i = 1, 12 do
			if(LevelMatrix.HitTest(tTiles, this.x, this.y + i * (vSpeed/math.abs(vSpeed)))) then
				vSpeed = -100 * (vSpeed/math.abs(vSpeed))
			end

			if(LevelMatrix.HitTest(tTiles, this.x + i * (hSpeed/math.abs(hSpeed)), this.y)) then
				hSpeed = -hSpeed / 2;
			end
		end
		if(player) then
	 		if(Engine.GetDistantion(this.x, this.y, player.x, player.y) < 128) then
				local dir = Engine.GetDirection(this.x, this.y, player.x, player.y)
				hSpeed = hSpeed + math.cos(dir) * 20
				vSpeed = vSpeed + math.sin(dir) * 20
				Gravity = 0
			else
				Gravity = 20
			end

			if(Engine.GetDistantion(this.x, this.y, player.x, player.y) < 16) then
				if(InsertItemInventory(this)) then
					Audio.PlayWithPitch(6, 1+math.random() * 0.5)
				end
			end
		end

		if(math.abs(hSpeed) > 40) then
			spr = Sprite[10][1];
		else
			spr = Sprite[7][1];
		end

		Power = Power + hSpeed/400

		if(Engine.GetDistantion(this.x, this.y, player.x, player.y) > 512) then
			ObjectRemove(this);
		end
	end

	this.draw = function(dt)
		love.graphics.setColor(255, 255, 255, 255)
		local quad = love.graphics.newQuad(0, 0, spr:getWidth(), spr:getHeight(), spr:getWidth(), spr:getHeight())
		love.graphics.draw(spr, quad, this.x, this.y, Power, 1, 1, spr:getWidth()/2, spr:getHeight()/2)
	end

	table.insert(Bullets, this)
end

function Chest(gx, gy)
	local this = {};
	this.x = gx * 32;
	this.y = gy * 32;


	local LootIndex = 1+math.floor(math.random()*7)
	local Loot = {
		function() for i = 1, 20 do Coin(this.x, this.y) end end,
		function() for i = 1, 20 do Coin(this.x, this.y) end end,
		function() for i = 1, 20 do Coin(this.x, this.y) end end,
		function() for i = 1, 20 do Coin(this.x, this.y) end end,
		function() Health(this.x + 16, this.y + 16) end,
		function() Health(this.x + 16, this.y + 16) end,
		function() Health(this.x + 16, this.y + 16) end,
		function() Health(this.x + 16, this.y + 16) end
	}
	local SpriteIndex = Sprite[11]
	local Opened = 0
	local Frame = love.graphics.newQuad(32 * Opened, 0, 32, 32, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());
	this.update = function(dt)
		Frame = love.graphics.newQuad(32 * Opened, 0, 32, 32, SpriteIndex[1]:getWidth(), SpriteIndex[1]:getHeight());

		if(love.keyboard.isDown('e') and Opened == 0 and Engine.GetDistantion(this.x + 16, this.y + 16, player.x, player.y) < 16) then
			Loot[LootIndex]()
			Opened = 1
		end
	end

	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(SpriteIndex[1], Frame, this.x, this.y)
	end

	table.insert(Bullets, this)
end

function Health(x, y)
	local this = {};
	this.x = x;
	this.y = y;
	this.id = 2
	this.name = "Health +10"
	this.func = function() player.HP = player.HP + 10 end

	local Alpha = 1;
	local SpriteIndex = Sprite[12][1]
	
	InsertItemInventory(this)
	this.update = function(dt)
		Alpha = Alpha - 0.01;

		if(Alpha < 0.01) then
			ObjectRemove(this)
		end

		this.y = this.y - 20 * dt;
	end

	this.draw = function()
		love.graphics.setColor(255, 255, 255, 255 * Alpha)
		love.graphics.draw(SpriteIndex, love.graphics.newQuad(0, 0, 48, 48, SpriteIndex:getWidth(), SpriteIndex:getHeight()), this.x, this.y, Alpha * 3.14, 1, 1, 24, 24)
	end

	table.insert(Bullets, this)
end

function InsertItemInventory(obj)
	for i = 0, 5 do
		if(Inv.Items[i+1] == obj.id) then
			Inv.ItemsCount[i+1] = Inv.ItemsCount[i+1] + 1;
			ObjectRemove(obj);
			return true;
		end
	end
	for i = 0, 5 do
		if(Inv.Items[i+1] == 0) then
			Inv.Items[i+1] = obj.id;
			Inv.ItemsCount[i+1] = Inv.ItemsCount[i+1] + 1;
			Inv.ItemsName[i+1] = obj.name;
			Inv.ItemsFunc[i+1] = obj.func;
			ObjectRemove(obj);
			return true;
		end
	end
	
	return false;
end