Particle = {};

function Particle.Type1(spr, x, y, dir, speed)
	local part = {}
	part.x = x;
	part.y = y;
	part.dir = dir + love.math.random(-math.pi/7, math.pi/7);
	part.grav = 10;
	part.vspeed = math.sin(part.dir) * speed;
	part.hspeed = math.cos(part.dir) * speed;

	part.update = function(dt) 
		part.x = part.x + part.hspeed * dt;
		part.y = part.y + part.vspeed * dt; part.vspeed = part.vspeed + part.grav

		if(LevelMatrix.HitTest(tTiles, part.x, part.y)) then
			Particle.Remove(part)
		end
	end

	part.draw = function()
		love.graphics.setColor(part.r, part.g, part.b, 255)
		local quad = love.graphics.newQuad(0, 0, spr:getWidth(), spr:getHeight(), spr:getWidth(), spr:getHeight())
		love.graphics.draw(spr, quad, part.x, part.y, 0, 0.5, 0.5, spr:getWidth()/2, spr:getHeight()/2)
	end

	table.insert(Particle, part);

	return part;
end

function Particle.Burst1(count, spr, x, y, dir, speed, r, g, b)
	for i = 1, count do
		local p = Particle.Type1(spr, x, y, dir, speed)
		p.r = r;
		p.g = g;
		p.b = b;
	end
end



function Particle.Remove(p) 
	for i, v in ipairs(Particle) do
		if(v == p) then
			v = nil
			table.remove(Particle, i)
		end
	end
end

function Particle.Update(dt)
	for i, v in ipairs(Particle) do
		v.update(dt)
	end
end

function Particle.Draw()
	for i, v in ipairs(Particle) do
		v.draw(dt)
	end
end