--Game Scene

Game = {};
Menu = {};
Options = {};
Logos = {};
QuitDialog = {};

	PosX = 64; PosY = 64
	Level = Generator.New(384, 384)
	Generator.GenerateLevel(Level)
	CurrentPath = 1;

--Game
Sector = 0;
Scores = 0;
Coins = 0;

CurrentTransform = Logos;
TimeTransistionBetweenScenes = 0;
TimerTransistionBetweenScenes = 0.8;

function Game.load()
	Music.Stop(2);
	ObjectsRemoveAll()
	Loading = true
	Level = Generator.New(384, 384)
	TimeToSpawn = 0;
	TimerToSpawn = 2;
	TimerToGenerate = 0;
	Pause = false;
	Engine.ViewPosition(48*32- 400, 384/2*32 - 240);
	player = PlayerCreate( 48, 384/2);
	TableEnem = {
		Zombie,
		CrazyBird
	};
	CurrentEnemy = math.floor(love.math.random(2))
	Music.Play(1);
	Music[1]:setVolume(0)
end

function Game.update(dt)
	if(Loading == false) then
		if(Pause == false) then
			player.Update(dt)
			ObjectsUpdate(dt)
			Music[1]:setVolume(0.7-(Alpha - 0.3))

			Engine.ViewPosition(player.x - love.window.getWidth()/2 + 0.5 * (Engine.MouseX - player.x)/2 + math.cos(player.Direction) * (player.Recoil * 8), player.y - love.window.getHeight()/2 + 0.5 * (Engine.MouseY - player.y)/2 + math.sin(player.Direction) * (player.Recoil * 8))


			--Enemies spawner
			TimeToSpawn = TimeToSpawn + dt;
			if(TimeToSpawn > TimerToSpawn and table.maxn(Enemies) < 10) then
				CurrentEnemy = math.floor(love.math.random(2))
				local i = 480
				local j = 480
				local n = 0

				while(i > 1) do
					if(LevelMatrix.HitTest(tTiles, -Engine.CameraX - 32, -Engine.CameraY + i) ~= true and LevelMatrix.GetCell(tTiles, -Engine.CameraX - 32, -Engine.CameraY + i) ~= 0) then
						TableEnem[CurrentEnemy](-Engine.CameraX - 32, -Engine.CameraY + i - 64, player)
						i = 1
					end

					i = i - 1;
				end
				while(j > 1) do
					if(LevelMatrix.HitTest(tTiles, -Engine.CameraX + love.window.getWidth() + 32, -Engine.CameraY + j) ~= true and LevelMatrix.GetCell(tTiles, -Engine.CameraX + love.window.getWidth() + 32, -Engine.CameraY + j) ~= 0) then
						TableEnem[CurrentEnemy](-Engine.CameraX  + love.window.getWidth() + 32, -Engine.CameraY + j - 64, player)
						j = 1;
					end

					j = j - 1;
				end

				while(n < 800) do
					if(LevelMatrix.GetCell(tTiles, -Engine.CameraX + n, -Engine.CameraY - 32) ~= 0 and LevelMatrix.HitTest(tTiles, -Engine.CameraX + n, -Engine.CameraY - 32) == false) then
						TableEnem[CurrentEnemy](-Engine.CameraX + n + 32, -Engine.CameraY - 64, player)
						n = 800;
					end

					n = n + 1;
				end
				TimeToSpawn = 0;
			end
		else
			if(love.keyboard.isDown("y")) then
				CurrentPath = 1;
				PosX = 64 - (400/32)
				PosY = 64 - (240/32)
				Alpha = 1;
				Engine.ChangeScene(Menu)
			end
		end
	else
		if(math.floor(LoadingTime) == 2) then
			Generator.GenerateLevel(Level)
			LoadingTime = 3
		end
		Alpha = 1;
		Music[1]:setVolume(0.7-(Alpha - 0.7))
	end

	Alpha = Alpha - (Alpha - 0)/8;
end

function Game.draw()
	if(Loading == false) then
		LevelMatrix.Display(tTiles)
	
		ObjectsDraw();
		player.Draw();
	end

	love.graphics.setColor(0, 0, 0, 255*Alpha);
	love.graphics.rectangle('fill', -Engine.CameraX, -Engine.CameraY, love.window.getWidth(), love.window.getHeight())
	love.graphics.setColor(255, 255, 255, 255)
end

function Game.reset()
	ObjectsRemoveAll()
	player = nil;
	Game.load();
end

function Game.free()
	ObjectsRemoveAll()
	Music.Stop(1);
	Music[1]:setVolume(0.7)
	Inv = InventoryInit();
	player = nil;
end

function Game.keypressed()
	if(Loading == false) then
		if(love.keyboard.isDown("escape")) then
			if(Pause == true) then Pause = false; Music[1]:setVolume(0.9) Inv.Opened = false; else Pause = true; Music[1]:setVolume(0.2) end;
		end

		if(love.keyboard.isDown('i')) then
			Inv.Opened = true
		end

		if(love.keyboard.isDown("r")) then
			Game.reset()
		end
	end
end

function Game.mousepressed()
	if(player) then player.MouseDown(); end
end


--Main Menu
function Menu.load()
	MainMenuLoad("Love to Escape")

	Music.Play(2)
	Music[2]:setVolume(0)

	StartGame = Button("Start Game", 256, function()  CurrentTransform = Game end)
	ButOpt = Button("Options", 256 + 32, function() CurrentTransform = Options end)
	Quit = Button("Quit", 256 + 96, function() CurrentTransform = QuitDialog end)
end

function Menu.update(dt)
	MainMenuUpdate(dt)
end

function Menu.draw()
	MainMenuDraw()
end

function Menu.mousereleased()
	ButtonsReleased()
end

function Menu.free()
	ButtonsDeleteAll()
	ObjectsRemoveAll()
end

--Options
function Options.load()
	MainMenuLoad("Options")

	ButSnd = Button("Sound: true", 256, function() if(ConfSound) then ConfSound = false else ConfSound = true end end)
	ButMsc = Button("Music: true", 256 + 32, function() if(ConfMusic) then ConfMusic = false; love.audio.stop() else ConfMusic = true; Music.Play(2) end end)

	Back = Button("Back", 256 + 96, function() Options.savesettings(); CurrentTransform = Menu end)
end

function Options.update(dt)
	ButSnd.title = "Sound: "+tostring(ConfSound)
	ButMsc.title = "Music: "+tostring(ConfMusic)

	MainMenuUpdate(dt)
end

function Options.draw()
	MainMenuDraw()
end

function Options.mousepressed()
	ButtonsReleased()
end

function Options.free()
	ButtonsDeleteAll()
end

function Options.savesettings()

	local f = FileWriteOpen('settings.cfg') 
	FileWrite(f, "ConfSound = "+tostring(ConfSound)+";\nConfMusic = "+tostring(ConfMusic)+";") 
	FileWriteClose(f)
end

--Logos
function Logos.load()
	Loading = true;
	LoveLogo = love.graphics.newImage('Graphics/Love2Dlogo.png')
	H2xLogo = love.graphics.newImage('Graphics/H2xLogo.png')

	LogoIndex = H2xLogo

	TimeToTrans = 1
	TimeTrans = 0
	Alpha = 0
	Trans = 1;
end

function Logos.update(dt)
	if Loading == false then
		TimeTrans = TimeTrans + dt;

		if(TimeTrans > TimeToTrans) then
			if(Trans == 0) then Trans = 1 if(LogoIndex ~= LoveLogo) then LogoIndex = LoveLogo; else Engine.ChangeScene(Menu) end else Trans = 0 end
			TimeTrans = 0
		end

		Alpha = Alpha - (Alpha - Trans)/16;
	end
end

function Logos.draw()
	Engine.ViewPosition(0, 0)
	love.graphics.setColor(255, 255, 255, 255*Alpha);
	local quad = love.graphics.newQuad(0, 0, LogoIndex:getWidth(), LogoIndex:getHeight(), LogoIndex:getWidth(), LogoIndex:getHeight())
	love.graphics.draw( LogoIndex, quad, love.window.getWidth()/2, love.window.getHeight()/2, 0, 1, 1, LogoIndex:getWidth()/2, LogoIndex:getHeight()/2)
end

function Logos.free()
	Alpha = 1
end

--Quit Dialog
function QuitDialog.load()
	MainMenuLoad("Do you want to exit?")

	ButYes = Button("Yes", 256, function() love.event.quit() end)
	ButNo = Button("No", 256 + 32, function() CurrentTransform = Menu end)
end

function QuitDialog.update(dt)
	MainMenuUpdate(dt)
end

function QuitDialog.draw()
	MainMenuDraw()
end

function QuitDialog.mousepressed()
	ButtonsReleased()
end

function QuitDialog.free()
	ButtonsDeleteAll()
end


function MainMenuLoad(str)
	Title = str
	TitlePow = 0;
	Scale = 0
end

function MainMenuUpdate(dt)
	TitlePow = TitlePow + 0.05;
	ButtonsUpdate(dt)
	if(CurrentScene == CurrentTransform) then 
		Scale = Scale - (Scale - 2)/8;
	else
		Scale = Scale - (Scale - 0)/8;
	end

	if(CurrentTransform == Game) then
		Alpha = Alpha - (Alpha - 1)/8;
	else
		Alpha = Alpha - (Alpha - 0)/8;
	end
	if(math.floor(CurrentPath) == table.maxn(Level.path)) then 
		Level = Generator.New(384, 384)
		Generator.GenerateLevel(Level)
		PosX, PosY = 48, 384/2
		CurrentPath = 1 
	else
		CurrentPath = CurrentPath + 0.6
	end
	Music[2]:setVolume(0.7-(Alpha - 0.3))
end

function MainMenuDraw()
	PosX = PosX - (PosX - Level.path[math.floor(CurrentPath)][1])/32
	PosY = PosY - (PosY - Level.path[math.floor(CurrentPath)][2])/32
	
	LevelMatrix.Display(tTiles)


	love.graphics.translate(-Engine.CameraX, -Engine.CameraY)
	love.graphics.draw(iVingette, love.graphics.newQuad(0, 0, 800, 480, 800, 480), 0, 0, 0, love.window.getWidth()/800, love.window.getHeight()/480)
	ButtonsDraw()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print(Title, love.window.getWidth()/2, 128, 0.06*Scale, 2 + math.cos(TitlePow*1.5)*0.2, Scale, gameFont:getWidth(Title)/2, gameFont: getHeight()/2)
		
	Engine.ViewPosition(PosX * 32 - 400, PosY * 32 - 240)

	love.graphics.setColor(0, 0, 0, 255*Alpha);
	love.graphics.rectangle('fill', 0, 0, love.window.getWidth(), love.window.getHeight())
	love.graphics.setColor(255, 255, 255, 255)

	love.graphics.print('0.1a by H2x\nMusic by Xenogenocide', 16, 16, 0, 0.5, 0.5)
end