--Engine for platformer Games
--@author H2x
--@twitter h2xdeveloper
getmetatable("").__add=function(s1,s2) return s1..s2 end --DON'T DELETE THIS

require 'TextWriter'


if(file_exists("settings.cfg")) then
	dofile("settings.cfg")
else
	ConfSound = true;
	ConfMusic = true;

	local f = FileWriteOpen('settings.cfg') 
	FileWrite(f, "ConfSound = true\nConfMusic = true") 
	FileWriteClose(f)
end
require 'Engine'
require 'Generator'
require 'Sounds'
require 'Objects'
require 'Scenes'

LoadingTime = 0;
LoadingFrame = 0;
LoadingQuad = love.graphics.newQuad(32 * LoadingFrame, 0, 48, 48, Sprite[8][1]:getWidth(), Sprite[8][1]:getHeight());

Loading = false;


CurrentScene = Logos;




function love.load()
	Engine.Init();
	if(CurrentScene.load) then 
		CurrentScene.load()
	else
		Engine.Error(Engine.ER_LOAD_NF);
	end
end

function love.update(dt)
	if Loading == true then
		LoadingTime = LoadingTime + dt
		if(LoadingTime > 5) then
			Loading = false
			LoadingTime = 0;
		end
		LoadingFrame = math.floor(LoadingFrame + 75 * dt);
		if(LoadingFrame > Sprite[8][2]) then
			LoadingFrame = 0;
		end

		LoadingQuad = love.graphics.newQuad(48 * LoadingFrame, 0, 48, 48, Sprite[8][1]:getWidth(), Sprite[8][1]:getHeight());
	end

	Engine.Update(dt);
	if(CurrentScene.update) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.update(dt)
		end
	else
		Engine.Error(Engine.ER_UPDATE_NF);
	end
end

function love.draw()
	

	love.graphics.translate(Engine.CameraX, Engine.CameraY)

	if(CurrentScene.draw) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.draw()
		end
	else
		Engine.Error(Engine.ER_DRAW_NF);
	end

	Engine.Gui()
	Engine.ErrorDisplay();
end

function love.mousepressed()
	if(CurrentScene.mousepressed) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.mousepressed()
		end
	end
end

function love.mousereleased(x, y, button)
	if(CurrentScene.mousereleased) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.mousereleased()
		end
	end
end

function love.keypressed()
	if(CurrentScene.keypressed) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.keypressed()
		end
	end
end

function love.keyreleased()
	if(CurrentScene.keyreleased) then 
		if(Engine.ErrorActive == false) then 
			CurrentScene.keyreleased()
		end
	end
end
